/* index.c
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiringPi.h>

#define MAXBUF  30

#define LEDPIN  27

int getParam(const char *params, const char *name, char *buf, char maxlen);

char *head =
"Content-Type: text/html;charset=utf-8\n\
\n\
<!DOCTYPE html>\n\
<html lang=\"it\">\n\
  <head>\n\
    <title>Raspberry-My Programmazione in C</title>\n\
    <meta charset=\"utf-8\">\n\
    <link rel=\"stylesheet\" type=\"text/css\" href=\"../../css/index.css\">\n\
    <script type=\"text/javascript\" src=\"../../js/index.js\"></script>\n\
  </head>\n\
  <body>\n\
    <!-- Dialog -->\n\
    <div id=\"isf_overlay\">\n\
      <div id=\"isf_overlay_frame\">\n\
        <div id=\"isf_overlay_content\">\n\
              <h2>\n\
                  Dialog modale visualizzato dal Javascript\n\
              </h2><p>\n\
                  &Egrave; possibile fare comparire un dialog sopra la pagina, che scompaia con un bottone.\n\
              </p>\n\
        </div>\n\
        <div id=\"isf_overlay_bottom\">\n\
          <input id=\"isf_overlay_close_button\" type=\"button\" onClick=\"closeDialog()\" value=\"Chiudi\">\n\
        </div>\n\
      </div>\n\
    </div>\n\
    <!-- Fine Dialog -->\n\
    <!-- Slideshow -->\n\
    <div id=\"testa-carousel\">\n\
      <div id=\"testa-slideshow\">\n\
            <img src=\"../../img/little_pi.png\" alt=\"Raspberry Pi 3\" width=\"400\" height=\"400\" />\n\
            <img src=\"../../img/raspberry-pi-2-angle-100569133-orig.png\" alt=\"Raspberry Pi 3\" width=\"400\" height=\"400\" />\n\
            <img src=\"../../img/Raspberry_Pi_-_Model_A.jpg\" alt=\"Raspberry Pi Model A\" width=\"400\" height=\"400\" />\n\
            <img src=\"../../img/rpi1bplus.png\" alt=\"Raspberry Pi 2\" width=\"400\" height=\"400\" />\n\
      </div>\n\
    </div>\n\
    <!-- Fine Slideshow -->\n\
    <script type=\"text/javascript\">var slides = new Slideshow('testa-slideshow', 1000, 400);</script>\n\
    <h1>Esempi di programmazione in C</h1>\n\
    <p>[<a href=\"../..\">Ritorna</a>]</p>\n\
    <p><input type=\"button\" onClick=\"openDialog()\" value=\"Apri Dialog\"></p>\n\
    <form method=\"get\" action=\"index.cgi\">\n\
      <p><input type=\"hidden\" name=\"led\" value=\"1\">\n\
      <input type=\"submit\" value=\"Accendi LED\"></p>\n\
    </form>\n\
    <form method=\"get\" action=\"index.cgi\">\n\
      <p><input type=\"hidden\" name=\"led\" value=\"0\">\n\
      <input type=\"submit\" value=\"Spegni LED\"></p>\n\
    </form>\n\
    <form method=\"get\" action=\"index.cgi\">\n\
      <p><input type=\"hidden\" name=\"led\" value=\"2\">\n\
      <input type=\"submit\" value=\"CiaoCiao\"></p>\n\
    </form>\n\
";


char *tail =
"  </body>\n\
</html>\n\
";

int main () {
  char *query = getenv("QUERY_STRING");

  wiringPiSetup ();
  pinMode (LEDPIN, OUTPUT) ;

  puts(head);
  if (query && query[0]) {
    char buf[MAXBUF];
    int led;
    if (!getParam(query, "led", buf, MAXBUF) || !buf[0]) {
      puts ("    <div class=\"error\">\n");
      puts ("      <h2>Il comando non pu&ograve; essere vuoto</h2>\n");
      puts ("    </div>\n");
    } else if (buf[0] != '-' && (buf[0] < '0' || buf[0] > '9')) {
      puts ("    <div class=\"error\">\n");
      puts ("      <h2>Il comando deve essere un numero</h2>\n");
      puts ("    </div>\n");
    } else {
      led = strtol(buf, (char**)0, 10);
      switch (led) {
        case 0:
          digitalWrite (LEDPIN, LOW);
          break;
        case 1:
          digitalWrite (LEDPIN, HIGH);
          break;
        default:
          break;
      }
    }
  }
  if (0 /* `gpio read 22` == '1' */) {
    puts ("    <div id=\"showbutton\" class=\"off\">\n");
  } else {
    puts ("    <div id=\"showbutton\" class=\"on\">\n");
  }
  puts ("    </div>\n");
  puts (tail);
  return 0;
}

int getParam(const char *params, const char *name, char *buf, char maxlen) {
  params = strstr(params, name);
  if (params) {
    params += strlen(name);
    if (*params++ != '=') {
      return FALSE;
    }
    while (*params && *params!= '&' && maxlen-- > 1) {
      *buf++ = *params++;
    }
    *buf = 0;
    return TRUE;
  }
  return FALSE;
}
